"use strict";
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageId = void 0;
var utils_1 = require("@typescript-eslint/utils");
exports.MessageId = "no-anonymous-use-effect-callback";
var REACT_TAG = "React";
var USE_EFFECT_TAG = "useEffect";
var rule = {
    defaultOptions: [],
    meta: {
        type: "layout",
        messages: (_a = {},
            _a[exports.MessageId] = "Functions passed to `useEffect` must be named to document intent. More info: https://x.com/housecor/status/1750980809874436431.",
            _a),
        schema: [],
    },
    create: function (context) {
        return {
            CallExpression: function (node) {
                if (![
                    utils_1.AST_NODE_TYPES.Identifier,
                    utils_1.AST_NODE_TYPES.MemberExpression,
                ].includes(node.callee.type)) {
                    return;
                }
                var callee = node.callee;
                // React.useEffect
                var isReactUseEffect = callee.object &&
                    callee.object.type === utils_1.AST_NODE_TYPES.Identifier &&
                    callee.object.name === REACT_TAG &&
                    callee.property &&
                    callee.property.type === utils_1.AST_NODE_TYPES.Identifier &&
                    callee.property.name === USE_EFFECT_TAG;
                // useEffect
                var isRegularUseEffect = node.callee.name === USE_EFFECT_TAG;
                if ((isReactUseEffect || isRegularUseEffect) &&
                    node.arguments.length > 0) {
                    var firstArgument = node.arguments[0];
                    if (firstArgument.type === utils_1.AST_NODE_TYPES.ArrowFunctionExpression ||
                        firstArgument.type === utils_1.AST_NODE_TYPES.FunctionExpression) {
                        var doesNotHaveIdentifier = !firstArgument.id || !firstArgument.id.name;
                        if (doesNotHaveIdentifier) {
                            context.report({
                                node: node.parent,
                                messageId: exports.MessageId,
                            });
                        }
                    }
                }
            },
        };
    },
};
exports.default = rule;
//# sourceMappingURL=no-anonymous-use-effect-callback.js.map